package de.fhw.swtprojekt.knauf.gridbaglayout;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**Dialog mit einen TextArea, das ber die ganze Dialoggre geht.
 * 
 * @author Wolfgang Knauf
 *
 */
public class DialogTextAreaMaximized extends JDialog
{
  /**SerialVersionUID muss sein, da Basisklasse serialisierbar.
   */
  private static final long serialVersionUID = 1L;

  /**Konstruktor initialisiert den Dialog.
   * 
   */
  public DialogTextAreaMaximized()
  {
    this.setSize(300, 300);
    this.setTitle("TextArea maximiert ber ganzen Dialog");
    //Wichtig: ein Dialog ist Modal!
    this.setModal(true);
    
    GridBagLayout gridBayLayout = new GridBagLayout();
    this.setLayout(gridBayLayout);
    
    //Ein TextArea zufgen. Damit das Scrollbar ist, kommt es auf ein JScrollPane.
    JScrollPane scrollPane = new JScrollPane();
    scrollPane.setName("scrollPane");
    
    //Es kommt in Zelle 0/0, soll in x- und y-Richtung den verfgbaren freien Platz einnehmen.
    gridBayLayout.setConstraints(scrollPane, new GridBagConstraints (0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0 ));
    this.add(scrollPane);
    
    //In das ScrollPane kommt ein TextArea:
    JTextArea textArea = new JTextArea();
    textArea.setName("textArea");
    scrollPane.getViewport().add(textArea);
  }

}
