package de.fhw.swtprojekt.knauf.gridbaglayout;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;

/**Hauptfenster der Anwendung
 * 
 * @author Wolfgang Knauf
 *
 */
public class MainWindow extends javax.swing.JFrame
{
  /**SerialVersionUID muss sein, da Basisklasse serialisierbar.
   */
  private static final long serialVersionUID = 1L;


  /**Konstruktor, erzeugt das Fenster.
   * 
   */
  public MainWindow()
  {
    this.setSize(300, 300);
    this.setTitle("GridBagLayout-Testanwendung");
    //Wenn ich mich beende, dann soll die Anwendung bitte tot sein!
    //Ansonsten wrde sie noch weiterleben, nur ohne sichtbares Fenster.
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
    GridBagLayout gridBayLayout = new GridBagLayout();
    this.setLayout(gridBayLayout);
    
    //Ein paar Buttons zufgen:
    JButton buttonTextAreaMax = new JButton ("TextArea maximiert");
    gridBayLayout.setConstraints(buttonTextAreaMax, new GridBagConstraints (0, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0 ));
    buttonTextAreaMax.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e)
      {
       buttonTextAreaMax_actionPerformed(e); 
      }
    });
    buttonTextAreaMax.setName("buttonTextAreaMax");
    this.add(buttonTextAreaMax);
    
    JButton buttonTextAreaButtons = new JButton ("TextArea mit zwei Buttons");
    gridBayLayout.setConstraints(buttonTextAreaButtons, new GridBagConstraints (0, 1, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0 ));
    buttonTextAreaButtons.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        buttonTextAreaButtons_actionPerformed(e); 
      }
    });
    buttonTextAreaButtons.setName("buttonTextAreaButtons");
    this.add(buttonTextAreaButtons);
    
    
    JButton button3x2TextAreas = new JButton ("3*2 TextAreas");
    gridBayLayout.setConstraints(button3x2TextAreas, new GridBagConstraints (0, 2, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0 ));
    button3x2TextAreas.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        button3x2TextAreas_actionPerformed(e); 
      }
    });
    button3x2TextAreas.setName("button3x2TextAreas");
    this.add(button3x2TextAreas);
    
  }
  
  /**Klick auf "Zeigt den Dialog an, der ein einziges maximiertes TextArea anzeigt.
   * @param e Das auslsende ActionEvent
   */
  private void buttonTextAreaMax_actionPerformed(ActionEvent e)
  {
    DialogTextAreaMaximized dialog = new DialogTextAreaMaximized();
    dialog.setVisible(true);
    
    dialog.dispose();
  }
  
  /**Klick auf "Zeigt den Dialog an, der ein maximiertes TextArea und zwei Buttons anzeigt.
   * @param e Das auslsende ActionEvent
   */
  private void buttonTextAreaButtons_actionPerformed(ActionEvent e)
  {
    DialogTextAreaButtons dialog = new DialogTextAreaButtons();
    dialog.setVisible(true);
    
    dialog.dispose();
  }
  
  /**Klick auf "Zeigt den Dialog an, der ein Grid aus 3*2 TextAreas anzeigt.
   * @param e Das auslsende ActionEvent
   */
  private void button3x2TextAreas_actionPerformed(ActionEvent e)
  {
    DialogMultiTextAreas dialog = new DialogMultiTextAreas();
    dialog.setVisible(true);
    
    dialog.dispose();
  }
}
